#include<unistd.h>
#include<sys/types.h>
#include<sys/mman.h>
#include<sys/time.h>
#include<stdio.h>
#include<stdlib.h>
#include<fcntl.h>
#include "logo.h"

void blt(int, int, int, int);
volatile unsigned short *regs;

const int sheight = 480;
const int swidth = 800;

int main(int argc, char **argv) {
	unsigned long rnd;
	unsigned short *fb;
	struct timeval begin, end;
	int i = 0, x, y, usecs;
	int fd = open("/dev/mem", O_RDWR|O_SYNC);

	regs = (unsigned short *)mmap(0, 4096, 
			PROT_READ|PROT_WRITE, MAP_SHARED, fd, 0x600ff000);
	fb = (unsigned short *)mmap(0, swidth * sheight * 2, 
			PROT_READ|PROT_WRITE, MAP_SHARED, fd, 0x60100000);
	regs += (0x30 / sizeof(unsigned short));
	regs[4] = 0x301;
	for (y = 0; y < 80; y++) {
		for (x = 0; x < 250; x++) {
			fb[(y * swidth) + x] = logo[i++];
		}
		fb[(y * swidth)] = 0xffff;
		fb[(y * swidth) + 249] = 0x001f;
	}
	for (x = 0; x < 250; x++) {
		fb[x] = 0xffff;
		fb[swidth * 79 + x] = 0x001f;
	}
	regs[4] = 0x300;
	gettimeofday(&begin, NULL);
	for (i= 0; i < 10000; i++) {
		srand(time() + i);	
		blt(0x80000, 
                    rand()%(sheight * swidth),
                    249, 
                    80);
	}
	gettimeofday(&end, NULL);
	usecs = (end.tv_sec - begin.tv_sec) * 1000000;
	usecs = usecs + (end.tv_usec - begin.tv_usec);
	printf("Did 10000 bit-blts in %d.%06d second.\n", usecs / 1000000,
	  usecs % 1000000); 
	close(fd);
}

void blt(int src, int dest, int width, int height) {
	regs[0] = (src >> 16) | ((dest >> 16) << 6) | ((width >> 7) << 13);
	regs[1] = (height & 0x1ff) | (width << 9);
	regs[2] = src & 0xffff;
	regs[3] = dest & 0xffff;
}
